# Run kubernetes into a vagrant cluster

## Introduction

To develop and test new ansible plays, k8scluster provide two virtual environments (Vagrantfile + Molecule).
- Vagrantfile is usefull to develop, debug and test new plays or new features into a sandbox.
- Molecule is used to run, check and test the full deployment into a VirtualBox private network managed by Vagrant.

By default, both create the same kind of cluster:
- 3 virtual machines
    - 1 master (k8s-master)
    - 2 nodes (k8s-node-1, k8s-node-2)
- 2 cpus and 3072 Mb memory per machine
- One of the following distribution, centos/7 by default if not specified.
    - CentOS 7
    - Debian 9 (Stretch)
    - Ubuntu 16.04.1 LTS (Xenial Xerus)
    - Ubuntu 18.04 LTS (Bionic Beaver)

## System requirements

- [VirtualBox 6.1.16r140961](https://www.virtualbox.org/)
- [Vagrant 2.2.14](https://www.vagrantup.com/downloads)
- [Python >=3.5](https://www.python.org/downloads/)
- [Ansible 2.10](../README.md)

If you are running Microsoft Windows, please insure to have WSL, VirtualBox and Vagrant properly installed ... good luck!<br>
FWIW, Visual Studio Code connected to a remote server with the Remote Development pack does the job pretty well.

However, for those you would like to use the ssh-agent on Windows, the following information may make their day.<br>
https://github.com/PowerShell/Win32-OpenSSH/issues/1263#issuecomment-699148072

## Development (Vagrantfile)

Supported distributions are documented into the Vagrant file.<br>
When the vagrant cluster is started, k8scluster is automatically deployed inside with the installation playbook.<br>
The cluster stays alive and availaible until you choose to stop it or destroy it.<br>

Cluster http(s) ports are mapped (NAT) on the host machine for full emulation purpose:
- http  -> 8080
- https -> 8443

Because, the ssh port is also mapped on the host machine, you can run other playbooks or replay a part of an existing directly with an ansible command.

From the repository root directory:
```bash
# Configure Ansible to use the dynamic inventory generated by Vagrant.
export ANSIBLE_INVENTORY="$(pwd)/.vagrant/provisioners/ansible/inventory/"
# Avoid any boring message about insecure key inside the vm ... it is a sandbox!
export ANSIBLE_HOST_KEY_CHECKING="False"

# Command to replay docker configuration on the master only.
ansible-playbook ./playbooks/k8scluster/install.yml --tags=docker,configure -l k8s-master
```

## Vagrantfile configuration
https://app.vagrantup.com/boxes/search

| Variable             | Default value | Sample value       | Comment                       |
|----------------------|---------------|--------------------|-------------------------------|
| K8SCLUSTER_IMAGE     | `centos/7`    | `debian/stretch64` | Vagrant Cloud box name.       |
| K8SCLUSTER_SHARE_SSH | `127.0.0.1`   | `0.0.0.0`          | Allowed IP for ssh connection |

## Useful Vagrant commands
https://www.vagrantup.com/docs/cli

From the repository root directory:
```bash
# Configure auto-completion (once forever)
vagrant autocomplete install --bash

# Start the cluster
vagrant up

# Enter the master
vagrant ssh k8-master

# Stop the cluster
vagrant halt

# Restart the cluster (without provisionning)
vagrant up --no-provision

# Destroy the cluster
vagrant destroy -f

## Get more commands
vagrant --help
```

## Ansible Tags
https://docs.ansible.com/ansible/latest/user_guide/playbooks_tags.html

To make easier development and debugging, each role is identified by a tag.
- docker
- kubernetes

Each command and command stage are also identified by a tag.
- install
- prepare
- download
- configure
- activate

## Tags Samples

| Usage                             | Action                                                   |
|-----------------------------------|----------------------------------------------------------|
| --tags=docker,install             | Run only docker full installation.                       |
| --tags=docker,configure           | Run only the configure stage of the docker installation. |
| --tags=docker,kubernetes,activate | Run only the activate stage of both docker & kubernetes. |

## How to connect to applications

All applications are available by their FQDN by default (ingress rule).

| Application    | FQDN                                         | Sample                                        |
|----------------|----------------------------------------------|-----------------------------------------------|
| kube-apiserver | `"{{ k8scluster_network_fqdn }}"`            | `https://k8scluster.nuci7.lan:6443`           |
| dashboard      | `"dashboard.{{ k8scluster_network_fqdn }}"`  | `https://dashboard.k8scluster.nuci7.lan:8443` | 
| grafana        | `"grafana.{{ k8scluster_network_fqdn }}"`    | `http://grafana.k8scluster.nuci7.lan:8080`    |
| nexus          | `"nexus.{{ k8scluster_network_fqdn }}"`      | `http://nexus.k8scluster.nuci7.lan:8080`      |
| prometheus     | `"prometheus.{{ k8scluster_network_fqdn }}"` | `http://prometheus.k8scluster.nuci7.lan:8080` |

`k8scluster_network_fqdn` can be customized into your specific inventory or with the `K8SCLUSTER_FQDN` environment variable.

As the **kube-apiserver** is available via ingress, [Lens](https://k8slens.dev/) can be used to manage the cluster.
